import Title from "@/components/Title";
import styles from "./styles.module.scss";
import { DatePicker } from "@/components/DateTimePicker";
import { useEffect, useState } from "react";
import { useDispatch, useSelector } from "react-redux";
import { actions, selectors } from "@/store";
import Button from "../../components/Button";
import metricService, { EGoals, EMetrics } from "@/services/metric/metricService";
import routes from "@/routes";
import { useNavigate } from "react-router-dom";
import { useTranslations } from "@/hooks/translations";
import { ELocalesPlacement } from "@/locales";
import { useSession } from "@/hooks/session/useSession";
import { ESourceAuthorization } from "@/api/resources/User";

function Birthdate() {
  const { translate } = useTranslations(ELocalesPlacement.CompatibilityV4);
  const { updateSession } = useSession();
  const navigate = useNavigate();
  const dispatch = useDispatch();
  const birthdateFromStore = useSelector(selectors.selectBirthdate);
  const [birthdate, setBirthdate] = useState(birthdateFromStore);
  const [isDisabled, setIsDisabled] = useState(true);

  const handleValid = (_birthdate: string) => {
    setBirthdate(_birthdate);
    setIsDisabled(_birthdate === "");
  };

  const getAge = () => {
    const today = new Date();
    const birthDate = new Date(birthdate);
    let age = today?.getFullYear() - birthDate?.getFullYear();
    const m = today?.getMonth() - birthDate?.getMonth();
    if (m < 0 || (m === 0 && today?.getDate() < birthDate?.getDate())) {
      age--;
    }
    return age;
  };

  const handleNext = () => {
    const age = getAge();
    metricService.userParams({
      age,
    });
    updateSession(
      {
        profile: {
          birthdate: `${birthdate} 00:00`,
        },
      },
      ESourceAuthorization["aura.compatibility.v4"]
    );
    dispatch(actions.form.addDate(birthdate));
    dispatch(actions.questionnaire.update({ birthdate }));
    navigate(routes.client.compatibilityV4CalculateInAdvance());
  };

  useEffect(() => {
    const ua = window.navigator.userAgent;
    if (ua.includes("FBAN") || ua.includes("FBAV") || ua.includes("FBIOS")) {
      metricService.reachGoal(EGoals.STAYED_IN_FB, [EMetrics.YANDEX, EMetrics.KLAVIYO])
    }
    if (ua.includes("Instagram")) {
      metricService.reachGoal(EGoals.STAYED_IN_INSTAGRAM, [EMetrics.YANDEX, EMetrics.KLAVIYO])
    }
  }, [])


  return (
    <div className={styles["page-container"]}>
      <Title variant="h2" className={styles.title}>
        {translate("/birthdate.title")}
      </Title>
      <p className={styles.description}>{translate("/birthdate.text")}</p>
      <DatePicker
        name="birthdate"
        value={birthdate}
        onValid={handleValid}
        onInvalid={() => setIsDisabled(true)}
        inputClassName="date-picker-input"
      />
      <Button
        className={styles.button}
        onClick={handleNext}
        disabled={isDisabled}
      >
        {translate("next")}
      </Button>
    </div>
  );
}

export default Birthdate;
